#!/bin/sh

export LC_ALL=POSIX

a= . install2-init-functions

# set TMPDIR to /tmp/.private/LOGNAME
exec_chroot control pam_mktemp enabled ||:

# turn off tmpfs
sed -i 's|^tmpfs|#tmpfs|' $destdir/etc/fstab ||:

# find free space for /tmp
BEST_SPACE=0
BEST_MP=
while read DEV MP X
do
    echo "$DEV" | grep -qe '^UUID=' || echo "$DEV" | grep -qe '^/dev/' || continue
    echo "$MP" | grep -qe '^/' || continue

    # tmpdir already configured
    if [ "$MP" == "/tmp" ]; then
	BEST_MP=
	((BEST_SPACE=0))
	break
    fi

    # check for writing
    if touch "$destdir/$MP"/_TEST_WRITE_
    then
	rm -f "$destdir/$MP"/_TEST_WRITE_
    else
	continue
    fi

    # check for free space
    MP_SPACE=$(echo `/bin/df "$destdir/$MP"| tail -n 1`| cut -d\  -f 4)
    if (($MP_SPACE > $BEST_SPACE)) ; then
	BEST_MP=$MP
	((BEST_SPACE=$MP_SPACE))
    fi
done < $destdir/etc/fstab

if (($BEST_SPACE > 0)) && [ -n "$BEST_MP" -a "$BEST_MP" != "/" -a ! -d "$destdir/$BEST_MP/tmp" ]
then

    # setup tmp mount point
    cp -ar $destdir/tmp "$destdir/$BEST_MP"/ ||:
    echo -e "$BEST_MP/tmp\t/tmp\tauto\tbind,rw\t0\t0" >> $destdir/etc/fstab ||:
fi
